<template>
  <div id="teacher_class_index_wrapper" class="bt-container">
    <h2 class="page-title">{{ $t('TEACHER_CLASS.ING_CLASS_LIST') }}</h2>     
      <!--뒤로가기 추가-->
      <div style="display:inline; float: right; margin-top: 40px; margin-bottom: 40px;">
        <a href="javascript:history.back();">
          <el-button size="small">{{ $t('ITEM_FROM_BANK.BACK') }}</el-button>
        </a>
      </div> 
    <class-list
      @row-click="onClickClass"
      @delete="onClickDelete"
      type="TEACHER"
      :list="teachingClassList || []"
      class="elTable-font"
      :isPhone="$isPhone"
    />
    <br />
    <!--
    <div class="right-align">-->
      <!--router-link to="/a/teacher/NNclass/new">
        <el-button  type="primary" :class="$attachReactablePostfix('right-align-btn')">
          <div class="right-align-btn-layer">{{ $t('TEACHER_CLASS.NEW_COURSE') }}</div>
        </el-button>
      </router-link-->
      <!--
      <el-button @click="onClick('NEW')" type="primary" :class="$attachReactablePostfix('right-align-btn')">
        <div class="right-align-btn-layer">주제 개설</div>
      </el-button>
      <router-link :to="`/a/teacher/NNclass/newfrombank`">
        <el-button type="primary" :class="$attachReactablePostfix('right-align-btn')" style="width: 49%">
          <div class="right-align-btn-layer">주제은행에서 가져오기</div>
        </el-button>
      </router-link>
    </div>
    -->
  </div>
</template>



<script>
import { mapState, mapMutations, mapActions } from 'vuex';
import ClassList from '../partials/ClassList';
import classService from '../../services/classService';
import authService from '../../services/authService';
import utils from '../../utils';


export default {
  name: 'TeacherClassIndex',

 
  async created() {
    const vm = this;
    // 학생이 url로 접근하는 경우 방지
    const accessId = utils.getUserIdFromJwt();
    const accessCheck = await authService.returnUserInfo({
      userID: accessId,
    });
    if (accessCheck.data.userInfo.type === 0) {
      vm.$router.push({ name: 'LandingPage' });
    }
  },
  components: {
    ClassList,
  },
   
  computed: {
    ...mapState('NNclass', [
      'teachingClassList',
    ]),
  },
  async beforeMount() {
    const vm = this;
    await vm.getMyClassLists();
  },
  methods: {
    ...mapMutations('NNclass', [
      'deleteTeachingClass',
    ]),
    ...mapMutations('auth', ['updateJwt', 'updateTemporalJwt', 'updateLocale']),
    ...mapActions('NNclass', [
      'getMyClassLists',
    ]),
    onClick(type) {
      const vm = this;
      switch (type) {
        case 'NEW': {
          vm.$notify({
            title: vm.$t('NOTIFY.TITLE'),
            message: vm.$t('TEACHER_CLASS.NEW_COURSE_LIMIT'),
            type: 'warning',
            duration: 5000,
          });
          break;
        }
        default: {
          throw new Error(`not defined type ${type}`);
        }
      }
    },
    onClickClass(row, _, column) {
      if (column.label === '-') {
        return;
      }
      const vm = this;
      vm.$router.push(`/a/teacher/NNclass/${row.class_id}`);
    },
    onClickDelete(index) {
      const vm = this;
      const currentTeachingClass = vm.teachingClassList[index];
      vm.$confirm(vm.$t('NOTIFY.WANT_DLT_SUBJ'), `${currentTeachingClass.name || ''} ` + vm.$t('CONFIRM.DELETE'), {
        confirmButtonText: vm.$t('NOTE.CONFIRM'),
        cancelButtonText: vm.$t('NOTIFY.CANCEL'),
        type: 'warning',
      }).then(async () => {
        try {
          // const index = vm.currentClassIndex;
          const currentClass = vm.teachingClassList[index];
          await classService.delete({
            id: currentClass.class_id,
          });
          vm.deleteTeachingClass({
            teachingClassIndex: index,
          });
        } catch (error) {
          console.error(error); // eslint-disable-line no-console
          vm.$notify({
            title: vm.$t('NOTIFY.FAIL_DEL_SUBJ'),
            message: error.toString(),
            type: 'error',
            duration: 3000,
          });
        }
      }).catch(() => {
        vm.$notify({
          title: vm.$t('NOTIFY.CANCELLED'),
          message: vm.$t('NOTIFY.SUBJ_DEL_CANC'),
          type: 'info',
          duration: 3000,
        });
      });
    },
  },
};
</script>

<style lang="scss" scoped>

#teacher_class_index_wrapper {
  .page-title {
    float:left;
    width: 1000px;
    height: 24px;
      
    font-family: SpoqaHanSans;
    font-size: 25px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1.2;
    letter-spacing: normal;
    color: #000000;
  
    margin-top : 40px;
    margin-left : 12px;
    margin-bottom : 25px;
  }
  .right-align {
      text-align: right;
  }
  
  .right-align-btn {
    width: 100%;
    height: 40px;
    border-radius: 3px;
    border: solid 1px #1989fa;
  }

  .right-align-btn-layer {
    width: 94px;
    height: 12px;
    font-family: SpoqaHanSans;
    font-size: 12px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    text-align: center;
    color: #ffffff;
    margin-left: auto;
    margin-right: auto;
  }
  
  .el-table th{
    font-family: SpoqaHanSans;
    font-size: 14px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    color: #909399;
  }

  .el-table td{
    font-family: SpoqaHanSans;
    font-size: 14px;
    font-weight: normal;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    color: #1989fa;
  }
}

.right-align-btn-phone {
  display: none;
}
</style>
